void UpdateCommandsPC()
{
	sprintf(text, "%X", PC);
	SendMessage(CommandsPCHandle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
}

void UpdateCommands()
{
	
	sprintf(text, "%X", PC);
	SendMessage(CommandsPCHandle,
					WM_SETTEXT, 0,
					(LPARAM)(LPCTSTR)text);
	SendMessage(hCommandList,LB_RESETCONTENT,(WPARAM)0,(LPARAM)0);
	SendMessage(hCommandList,LB_INSERTSTRING,(WPARAM)-1,
		(LPARAM)"PC         Opcode     Instruction");
		
	for (q=x+PC;q<=x+1020+PC;q=q+4)
	{
	//SetFilePointer(RomHandle,z+64-OldPC,0,FILE_BEGIN);
	//ReadFile(RomHandle,four,4,&dwRead,NULL);
	four[0]=ReadMemory(q, hWndMain);
	four[1]=ReadMemory(q+1, hWndMain);
	four[2]=ReadMemory(q+2, hWndMain);
	four[3]=ReadMemory(q+3, hWndMain);
	sprintf(text, "%.8X",q);
	sprintf(textt, "   %.2X%.2X%.2X%.2X   ",four[0],four[1],four[2],four[3]);
	strcat(text,textt);
	Instruction=(four[0] <<24) + (four[1] << 16) +(four[2] <<8) +four[3];
	debug.op=Instruction >> 26;
	debug.rs=(Instruction << 6) >> 27;
	debug.rt=(Instruction << 11) >> 27;
	debug.immediate=(Instruction << 16) >> 16;
	debug.target=(Instruction << 6) >> 6;
	debug.rd=(Instruction << 16) >> 27;
	debug.sa=(Instruction << 21) >> 28;
	debug.funct=(Instruction << 26) >> 26;
	debug.code=(Instruction << 6) << 12;
	debug.codea=(Instruction << 16)  >> 22;
	debug.codeb=(Instruction << 21) >> 21;
	strcat(text, AddOp());
	SendMessage(hCommandList,LB_INSERTSTRING,(WPARAM)-1,
		(LPARAM)text);
	}
}

char * AddOp() // Descrip: rd = (rs AND immediate)
{
	switch(debug.op)
	{
	case J:
		strcpy(textt, "J ");
		sprintf(space, "%X",debug.target);
		strcat(textt, space);
		return textt;
	case ANDI:
		strcpy(textt, "ANDI ");
		strcat(textt, AddGPR(debug.rt)); strcat(textt, ",");
		strcat(textt, AddGPR(debug.rs)); strcat(textt, ",");
		sprintf(space, "%X",debug.immediate);
		strcat(textt, space);
		return textt;
	case COP1:
		strcpy(textt, "COP1");
		return textt;
		break;
	case ORI:
		strcpy(textt, "ORI ");
		strcat(textt, AddGPR(debug.rt)); strcat(textt, ",");
		strcat(textt, AddGPR(debug.rs)); strcat(textt, ",");
		sprintf(space, "%X",debug.immediate);
		strcat(textt, space);
		return textt;
		break;
	case LB:
		strcpy(textt, "LB ");
		strcat(textt, AddGPR(debug.rt)); strcat(textt, ",");
		sprintf(space, "%X",debug.immediate+debug.rs);
		strcat(textt, space);
		return textt;
		break;
	case LW:
		strcpy(textt, "LW ");
		strcat(textt, AddGPR(debug.rt));strcat(textt,",");
		sprintf(space, "%X",debug.immediate);
		strcat(textt, space);
		strcat(textt,"(");
		strcat(textt, AddGPR(debug.rs));
		strcat(textt,")");
		return textt;
		break;
	case LUI:
		strcpy(textt, "LUI ");
		strcat(textt, AddGPR(debug.rt)); strcat(textt,",");
		sprintf(space, "0x%X",debug.immediate);
		strcat(textt, space);
		return textt;
		break;
	case BNE:
		if(debug.rt)
		{
		strcpy(textt, "BNE ");
		strcat(textt, AddGPR(debug.rs)); strcat(textt, ",");
		strcat(textt, AddGPR(debug.rt)); strcat(textt, ",");
		sprintf(space, "0x%X",q+((signed _int32)(debug.immediate)<<2));
		strcat(textt, space);
		}
		else
		{
		strcpy(textt, "BNEZ ");
		strcat(textt, AddGPR(debug.rs)); strcat(textt, ",");
		sprintf(space, "0x%X",q+((signed _int32)(debug.immediate)<<2));
		//sprintf(space, "0x%X",((signed _int32)debug.immediate));
		strcat(textt, space);
		}
		return textt;
		break;
	case BEQ:
		strcpy(textt, "BEQ ");
		strcat(textt, AddGPR(debug.rs)); strcat(textt, ",");
		strcat(textt, AddGPR(debug.rt)); strcat(textt, ",");
		sprintf(space, "%X",debug.immediate);
		strcat(textt, space);
		return textt;
		break;
	case JAL:
		strcpy(textt, "JAL ");
		sprintf(space, "%X",debug.target);
		strcat(textt, space);
		return textt;
		break;
	case LBU:
		strcpy(textt, "LBU ");
		strcat(textt, AddGPR(debug.rt));strcat(textt,",");
		sprintf(space, "%x",debug.immediate);
		strcat(textt, space);
		strcat(textt,"(");
		sprintf(space, "%x",debug.rs);
		strcat(textt, space);
		strcat(textt,")");
		return textt;
		break;
	case LD:
		strcpy(textt, "LD ");
		strcpy(textt, AddGPR(debug.rt)); strcat(textt, ",");
		sprintf(space, "%x",debug.immediate);
		strcat(textt, space);
		strcat(textt, "(");
		strcat(textt, AddGPR(debug.rs));
		strcat(textt, ")");return textt;
		break;
	case SW:
		strcpy(textt, "SW ");
		strcat(textt, AddGPR(debug.rt));strcat(textt, ",");
		sprintf(space, "%x",debug.immediate);
		strcat(textt, space);
		strcat(textt, "(");
		strcat(textt, AddGPR(debug.rs));
		strcat(textt, ")");
		return textt;
		break;
	
	case ADDI:
		strcpy(textt, "ADDI ");
		strcat(textt, AddGPR(debug.rt)); strcat(textt, ",");
		strcat(textt, AddGPR(debug.rs)); strcat(textt, ",");
		sprintf(space, "%x",debug.immediate);
		strcat(textt, space);
		return textt;
		break;
	case ADDIU:
		strcpy(textt, "ADDIU ");
		strcat(textt, AddGPR(debug.rt)); strcat(textt, ",");
		strcat(textt, AddGPR(debug.rs)); strcat(textt, ",");
		sprintf(space, "%x",debug.immediate);
		strcat(textt, space);
		return textt;
		break;
	case 0:
	switch(debug.funct)
	{
	case JR:
		strcpy(textt, "JR ");
		strcat(textt, AddGPR(debug.rs));
		return textt;
	case XOR:
		strcpy(textt, "XOR ");
		strcat(textt, AddGPR(debug.rd)); strcat(textt, ",");
		strcat(textt, AddGPR(debug.rs)); strcat(textt, ",");
		strcat(textt, AddGPR(debug.rt));
		return textt;
	case NOP:
		return "NOP";
	case SYNC:
		return "SYNC";
		break;
	 case ADD:
		return "ADD";
		break;
	 case ADDU:
		return "ADDU";
		break;
	 case AND:
		return "AND";
        break;
	 case DADD:
		 return "DADD";
		 break;
	 case DADDU:
		 return "DADDU";
		 break;
	 case DDIV:
		return "DDIV";
		break;
	 case DDIVU:
		 return "DDIVU";
		 break;
	 case DIV:
		 return "DIV";
		 break;
	 case DIVU:
		 return "DIVU";
		 break;
	 case DSLL:
		 return "DSLL";
		 break;
	 case DSLL32:
		 return "DSLL32";
		 break;
	 case DSLLV:
		 return "DSLLV";
		 break;
	 case 59:
		 return "DSRA";
		 break;
	 case DSRA32:
		 return "DSRA32";
		 break;
	 case 23:
		 return "DSRAV";
		 break;
	 case 58:
		 return "DSRL";
		 break;
	 case 62:
		 return "DSRL32";
		 break;
	 case 22:
		 return "DSRLV";
		 break;
	 case 46:
		 return "DSUB";
		 break;
	 case 47:
		 return "DSUBU";
		 break;
	 case 16:
		 return "MFHI";
		 break;
	 case MFLO:
		 return "MFLO";
		 break;
	 case MTHI:
		 return "MTHI";
		 break;
	 case MTLO:
		 return "MTLO";
		 break;
	 case 24:
		 return "MULT";
		 break;
	 case 25:
		 return "MULTU";
		 break;
	 case 39:
		 strcpy(textt, "NOR ");
		 strcat(textt, AddGPR(debug.rd)); strcat(textt,",");
		 strcat(textt, AddGPR(debug.rs)); strcat(textt,",");
		 strcat(textt, AddGPR(debug.rt));
		 return textt;
         break;
	 case 37:
		 strcpy(textt, "OR ");
		 strcat(textt, AddGPR(debug.rd)); strcat(textt,",");
		 strcat(textt, AddGPR(debug.rs)); strcat(textt,",");
		 strcat(textt, AddGPR(debug.rt));
		 return textt;
         break;
		  case BREAK:
		 strcpy(textt, "BREAK ");
		sprintf(space, "%x",debug.code);
		strcat(textt, space);
		return textt;
	default:
		sprintf(textt, "Op: %X Funct: %X", debug.op,debug.funct);
		return textt;
		break;
	}
		break;
	case 16:
	switch(debug.rs)
		{
	case MTC0:
		strcpy(textt,"MTC0 ");
		strcat(textt,AddCP0(debug.rd)); strcat(textt,",");
		strcat(textt,AddGPR(debug.rt));
		return textt;
		break;
	
	 case 0:
		 // SLL or NOP
		 if(debug.sa==0)
		 {
			return "NOP";
			break;
		 }
		 else
		 {
			return "SLL";
		 }
		 break;
	
		 default:
		sprintf(textt, "Op: %X rs: %X", debug.op,debug.rs);
		return textt;
		break;
		}
		break;
	default:
		sprintf(textt, "Unknown 1:%X", debug.op);
		return textt;
		break;
	}
}


char * AddCP0(int q)
{
	switch(q)
	{
	case 0:
		return "Index";
		break;
	case 1:
		return "Random";
		break;
	case 2:
		return "EntryLo0";
		break;
	case 3:
		return "EntryLo1";
		break;
	case 4:
		return "Context";
		break;
	case 5:
		return "PageMask";
		break;
	case 6:
		return "Wired";
		break;
	case 7:
		return "r7";
		break;
	case 8:
		return "BadVAddr";
		break;
	case 9:
		return "Count";
		break;
	case 10:
		return "EntryHi";
		break;
	case 11:
		return "Compare";
		break;
	case 12:
		return "Status";
		break;
	case 13:
		return "Cause";
		break;
	case 14:
		return "EPC";
		break;
	case 15:
		return "PRevID";
		break;
	case 16:
		return "Config";
		break;
	case 17:
		return "LLAddr";
		break;
	case 18:
		return "WatchLo";
		break;
	case 19:
		return "WatchHi";
		break;
	case 20:
		return "XContext";
		break;
	case 21:
		return "r21";
		break;
	case 22:
		return "r22";
		break;
	case 23:
		return "r23";
		break;
	case 24:
		return "r24";
		break;
	case 25:
		return "r25";
		break;
	case 26:
		return "PErr";
		break;
	case 27:
		return "CacheErr";
		break;
	case 28:
		return "TagLo";
		break;
	case 29:
		return "TagHi";
		break;
	case 30:
		return "ErrorEPC";
		break;
	case 31:
		return "r31";
		break;
	default:
		return "Unknown";
	}
}

char * AddGPR(int q)
{
	switch(q)
	{
	case 0:
		return "r0";
		break;
	case 1:
		return "at";
		break;
	case 2:
		return "v0";
		break;
	case 3:
		return "v1";
		break;
	case 4:
		return "a0";
		break;
	case 5:
		return "a1";
		break;
	case 6:
		return "a2";
		break;
	case 7:
		return "a3";
		break;
	case 8:
		return "t0";
		break;
	case 9:
		return "t1";
		break;
	case 10:
		return "t2";
		break;
	case 11:
		return "t3";
		break;
	case 12:
		return "t4";
		break;
	case 13:
		return "t5";
		break;
	case 14:
		return "t6";
		break;
	case 15:
		return "t7";
		break;
	case 16:
		return "s0";
		break;
	case 17:
		return "s1";
		break;
	case 18:
		return "s2";
		break;
	case 19:
		return "s3";
		break;
	case 20:
		return "s4";
		break;
	case 21:
		return "s5";
		break;
	case 22:
		return "s6";
		break;
	case 23:
		return "s7";
		break;
	case 24:
		return "t8";
		break;
	case 25:
		return "t9";
		break;
	case 26:
		return "k0";
		break;
	case 27:
		return "k1";
		break;
	case 28:
		return "gp";
		break;
	case 29:
		return "sp";
		break;
	case 30:
		return "s8";
		break;
	case 31:
		return "ra";
		break;
	default:
		return "Unknown";
	}
}