#define INT		0  // Interrupt
#define MOD		1  // TLB Modification exception
#define TLBL	2  // TLB Miss exception 
				   // (load or instruction fetch)
#define TLBS	3  // TLB Miss exception (store)
#define ADEL	4  // Address Error exception
				   // (load or instruction fetch)
#define ADES	5  // Address Error exception (store)
#define IBE		6  // Bus Error exception (instruction fetch)
#define	DBE		7  // Bus Error exception 
				   // (data reference: load or store)
#define SYS		8  // SYSCALL exception
#define BP		9  // Breakpoint exception
#define RI		10 // Reserved Instruction exception
#define CPU		11 // Coprocessor Unusable exception
#define OV		12 // Arithmetic Overflow exception
#define TR		13 // Trap exception
#define FPE		15 // Floating-Point exception
#define WATCH	23 // Watch exception
